#include <cstrike>

new Handle:h_cvar_bp;
new Handle:h_cvar_anon;
new say_functions[MAXPLAYERS+1];

public Plugin:myinfo =
{
	name = "Bot Replace",
	author = "Vitamin",
	description = "If player killed, player may say in chat !bbot, and AI player replace killed Realistic Player",
	version = "1.0",
	url = ""
}

public OnPluginStart()
{
	h_cvar_bp = CreateConVar("sm_bot_price", "2000", "Set amount cash for buy bot,", FCVAR_NOTIFY, true, 0.0, true, 16000.0);
	h_cvar_anon = CreateConVar("sm_advert_byu", "1", "If true, then When Round Start players will be Advert about instruction Plugin", _, true, 0.0, true, 1.0);
	RegConsoleCmd("sm_bbot", Hook_Say, "Buying Bot for price.");
	HookEvent("round_start", Event_RoundStart);
	HookEvent("round_end", Event_RoundEnd);
	LoadTranslations("bot_replace.phrases");
}

public OnMapStart()
{
	decl String:map_name[33];
	GetCurrentMap(map_name, sizeof(map_name));
	decl String:nav_path[37];
	Format(nav_path, sizeof(nav_path), "maps/%s.nav", map_name);
	if (!FileExists(nav_path, true))
	{
		decl String:path_file[PLATFORM_MAX_PATH];
		GetPluginFilename(GetMyHandle(), path_file, sizeof(path_file));
		ServerCommand("sm plugins unload %s", path_file);
	}
}

public Event_RoundEnd(Handle:event, const String:name[], bool:dontBroadcast)
{
	for (new i_client_bot = 1;i_client_bot <= GetMaxClients(); i_client_bot++)
	{
		if (!IsClientInGame(i_client_bot) || !IsFakeClient(i_client_bot))
		{
			continue;
		}
		else if (IsFakeClient(i_client_bot))
		{
			ServerCommand("bot_kick");
		}
	}
}

public Event_RoundStart(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (GetConVarBool(h_cvar_anon))
	{
		for (new i_client = 1; i_client <= GetMaxClients(); i_client++)
		{
			if (!IsClientInGame(i_client) || IsFakeClient(i_client))
			{
				continue;
			}
			if (say_functions[i_client] == 1)
			{
				say_functions[i_client] = 0;
			}
			PrintToChat(i_client, "[SM] %t", "Advert Text");
		}
	}
}

public Action:Hook_Say(client, args)
{
	if (args == 0)
	{
		if (!IsPlayerAlive(client))
		{
			if (GetClientTeam(client) != CS_TEAM_SPECTATOR)
			{
				if (say_functions[client] == 0)
				{
					new player_cash = GetEntProp(client, Prop_Send, "m_iAccount");
					new price_buy = GetConVarInt(h_cvar_bp);
					if (price_buy <= player_cash)
					{
						say_functions[client] = 1;
						SetEntProp(client, Prop_Send, "m_iAccount", player_cash - price_buy);
						new player_team = GetClientTeam(client);
						if (player_team == CS_TEAM_CT)
						{
							ServerCommand("bot_add_t");
						}
							else if (player_team == CS_TEAM_T)
						{
							ServerCommand("bot_add_ct");
						}
					}
					else
					{
						PrintToChat(client, "[SM] %t", "Need Cash");
					}
				}
				else
				{
					PrintToChat(client, "[SM] %t", "Bot Buying");
				}
			}
			else
			{
				PrintToChat(client, "[SM] %t", "Team Not Spec");
			}
		}
		else
		{
			PrintToChat(client, "[SM] %t", "Is Dead");
		}
	}
	return Plugin_Handled;
}